/* InternetView.c generated by valac 0.56.8, the Vala compiler
 * generated from InternetView.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "parental-controls.h"
#include <act/act.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <polkit/polkit.h>
#include <glib/gi18n-lib.h>

#define PC_WIDGETS_INTERNET_BOX_URL_REGEX "[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.[a-z]{2,4}\\b([-a-zA-Z0-9@:%_\\+.~#?&" \
"//=]*)"

enum  {
	PC_WIDGETS_INTERNET_BOX_0_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_USER_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_NUM_PROPERTIES
};
static GParamSpec* pc_widgets_internet_box_properties[PC_WIDGETS_INTERNET_BOX_NUM_PROPERTIES];
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PcWidgetsInternetBoxLoadExistingData PcWidgetsInternetBoxLoadExistingData;

#define PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY (pc_widgets_internet_box_url_entry_get_type ())
#define PC_WIDGETS_INTERNET_BOX_URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry))
#define PC_WIDGETS_INTERNET_BOX_URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntryClass))
#define PC_WIDGETS_INTERNET_BOX_IS_URL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY))
#define PC_WIDGETS_INTERNET_BOX_IS_URL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY))
#define PC_WIDGETS_INTERNET_BOX_URL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntryClass))

typedef struct _PCWidgetsInternetBoxUrlEntry PCWidgetsInternetBoxUrlEntry;
typedef struct _PCWidgetsInternetBoxUrlEntryClass PCWidgetsInternetBoxUrlEntryClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PCWidgetsInternetBoxUrlEntryPrivate PCWidgetsInternetBoxUrlEntryPrivate;
enum  {
	PC_WIDGETS_INTERNET_BOX_URL_ENTRY_0_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY,
	PC_WIDGETS_INTERNET_BOX_URL_ENTRY_NUM_PROPERTIES
};
static GParamSpec* pc_widgets_internet_box_url_entry_properties[PC_WIDGETS_INTERNET_BOX_URL_ENTRY_NUM_PROPERTIES];

struct _PCWidgetsInternetBoxPrivate {
	ActUser* _user;
	GRegex* url_regex;
	GtkListBox* list_box;
	GtkEntry* entry;
	GtkButton* add_button;
};

struct _PcWidgetsInternetBoxLoadExistingData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PCWidgetsInternetBox* self;
	gchar** block_urls;
	PCIParentalControls* _tmp0_;
	ActUser* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gchar** _tmp4_;
	gint block_urls_length1;
	gint _block_urls_size_;
	gchar** url_collection;
	gint url_collection_length1;
	gint _url_collection_size_;
	gint url_it;
	const gchar* url;
	const gchar* _tmp5_;
	GError* e;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _PCWidgetsInternetBoxUrlEntry {
	GtkListBoxRow parent_instance;
	PCWidgetsInternetBoxUrlEntryPrivate * priv;
};

struct _PCWidgetsInternetBoxUrlEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _PCWidgetsInternetBoxUrlEntryPrivate {
	gchar* _url;
};

static gint PCWidgetsInternetBox_private_offset;
static gpointer pc_widgets_internet_box_parent_class = NULL;
static gint PCWidgetsInternetBoxUrlEntry_private_offset;
static gpointer pc_widgets_internet_box_url_entry_parent_class = NULL;

static void pc_widgets_internet_box_load_existing_data_free (gpointer _data);
static void pc_widgets_internet_box_load_existing (PCWidgetsInternetBox* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void pc_widgets_internet_box_load_existing_finish (PCWidgetsInternetBox* self,
                                                   GAsyncResult* _res_);
static gboolean pc_widgets_internet_box_load_existing_co (PcWidgetsInternetBoxLoadExistingData* _data_);
static void pc_widgets_internet_box_load_existing_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void pc_widgets_internet_box_add_entry (PCWidgetsInternetBox* self,
                                        const gchar* url);
static void pc_widgets_internet_box_update_block_urls (PCWidgetsInternetBox* self);
static GType pc_widgets_internet_box_url_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static const gchar* pc_widgets_internet_box_url_entry_get_url (PCWidgetsInternetBoxUrlEntry* self);
static void _vala_array_add4 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void pc_widgets_internet_box_on_entry_changed (PCWidgetsInternetBox* self);
static void pc_widgets_internet_box_on_entry_activate (PCWidgetsInternetBox* self);
static PCWidgetsInternetBoxUrlEntry* pc_widgets_internet_box_url_entry_new (const gchar* url);
static PCWidgetsInternetBoxUrlEntry* pc_widgets_internet_box_url_entry_construct (GType object_type,
                                                                           const gchar* url);
static void __lambda14_ (PCWidgetsInternetBox* self);
static void ___lambda14__gtk_widget_destroy (GtkWidget* _sender,
                                      gpointer self);
static void pc_widgets_internet_box_url_entry_set_url (PCWidgetsInternetBoxUrlEntry* self,
                                                const gchar* value);
static GObject * pc_widgets_internet_box_url_entry_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void _pc_widgets_internet_box_url_entry___lambda13_ (PCWidgetsInternetBoxUrlEntry* self);
static void __pc_widgets_internet_box_url_entry___lambda13__gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self);
static void pc_widgets_internet_box_url_entry_finalize (GObject * obj);
static GType pc_widgets_internet_box_url_entry_get_type_once (void);
static void _vala_pc_widgets_internet_box_url_entry_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_pc_widgets_internet_box_url_entry_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);
static GObject * pc_widgets_internet_box_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _pc_widgets_internet_box_on_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _pc_widgets_internet_box_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                     gpointer self);
static void _pc_widgets_internet_box_on_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                                    gpointer self);
static void pc_widgets_internet_box_finalize (GObject * obj);
static GType pc_widgets_internet_box_get_type_once (void);
static void _vala_pc_widgets_internet_box_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_pc_widgets_internet_box_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
pc_widgets_internet_box_get_instance_private (PCWidgetsInternetBox* self)
{
	return G_STRUCT_MEMBER_P (self, PCWidgetsInternetBox_private_offset);
}

PCWidgetsInternetBox*
pc_widgets_internet_box_construct (GType object_type,
                                   ActUser* user)
{
	PCWidgetsInternetBox * self = NULL;
	g_return_val_if_fail (user != NULL, NULL);
	self = (PCWidgetsInternetBox*) g_object_new (object_type, "user", user, NULL);
	return self;
}

PCWidgetsInternetBox*
pc_widgets_internet_box_new (ActUser* user)
{
	return pc_widgets_internet_box_construct (PC_WIDGETS_TYPE_INTERNET_BOX, user);
}

static void
pc_widgets_internet_box_load_existing_data_free (gpointer _data)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (PcWidgetsInternetBoxLoadExistingData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
pc_widgets_internet_box_load_existing (PCWidgetsInternetBox* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
	PCWidgetsInternetBox* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (PcWidgetsInternetBoxLoadExistingData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, pc_widgets_internet_box_load_existing_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	pc_widgets_internet_box_load_existing_co (_data_);
}

static void
pc_widgets_internet_box_load_existing_finish (PCWidgetsInternetBox* self,
                                              GAsyncResult* _res_)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
pc_widgets_internet_box_load_existing_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	PcWidgetsInternetBoxLoadExistingData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	pc_widgets_internet_box_load_existing_co (_data_);
}

static gboolean
pc_widgets_internet_box_load_existing_co (PcWidgetsInternetBoxLoadExistingData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp0_ = pc_utils_get_api ();
		_data_->_tmp1_ = _data_->self->priv->_user;
		_data_->_tmp2_ = act_user_get_user_name (_data_->_tmp1_);
		_data_->_tmp3_ = 0;
		_data_->_state_ = 1;
		pc_iparental_controls_get_user_daemon_block_urls (_data_->_tmp0_, _data_->_tmp2_, pc_widgets_internet_box_load_existing_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp4_ = pc_iparental_controls_get_user_daemon_block_urls_finish (_data_->_tmp0_, _data_->_res_, &_data_->_tmp3_, &_data_->_inner_error0_);
		_data_->block_urls = _data_->_tmp4_;
		_data_->block_urls_length1 = _data_->_tmp3_;
		_data_->_block_urls_size_ = _data_->block_urls_length1;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		{
			_data_->url_collection_length1 = 0;
			_data_->_url_collection_size_ = 0;
			_data_->url_collection = _data_->block_urls;
			_data_->url_collection_length1 = _data_->block_urls_length1;
			for (_data_->url_it = 0; _data_->url_it < _data_->url_collection_length1; _data_->url_it = _data_->url_it + 1) {
				_data_->url = _data_->url_collection[_data_->url_it];
				{
					_data_->_tmp5_ = _data_->url;
					pc_widgets_internet_box_add_entry (_data_->self, _data_->_tmp5_);
				}
			}
		}
		_data_->block_urls = (_vala_array_free (_data_->block_urls, _data_->block_urls_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp6_ = _data_->e;
		_data_->_tmp7_ = _data_->_tmp6_->message;
		g_critical ("InternetView.vala:128: %s", _data_->_tmp7_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
_vala_array_add4 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
pc_widgets_internet_box_update_block_urls (PCWidgetsInternetBox* self)
{
	PolkitPermission* _tmp0_;
	gchar** block_urls = NULL;
	gchar** _tmp1_;
	gint block_urls_length1;
	gint _block_urls_size_;
	GtkListBox* _tmp2_;
	GList* _tmp3_;
	PCIParentalControls* _tmp8_;
	ActUser* _tmp9_;
	const gchar* _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = pc_utils_get_permission ();
	if (!g_permission_get_allowed ((GPermission*) _tmp0_)) {
		return;
	}
	_tmp1_ = g_new0 (gchar*, 0 + 1);
	block_urls = _tmp1_;
	block_urls_length1 = 0;
	_block_urls_size_ = block_urls_length1;
	_tmp2_ = self->priv->list_box;
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
	{
		GList* url_entry_collection = NULL;
		GList* url_entry_it = NULL;
		url_entry_collection = _tmp3_;
		for (url_entry_it = url_entry_collection; url_entry_it != NULL; url_entry_it = url_entry_it->next) {
			GtkWidget* url_entry = NULL;
			url_entry = (GtkWidget*) url_entry_it->data;
			{
				GtkWidget* _tmp4_;
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				_tmp4_ = url_entry;
				_tmp5_ = pc_widgets_internet_box_url_entry_get_url (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry));
				_tmp6_ = _tmp5_;
				_tmp7_ = g_strdup (_tmp6_);
				_vala_array_add4 (&block_urls, &block_urls_length1, &_block_urls_size_, _tmp7_);
			}
		}
		(url_entry_collection == NULL) ? NULL : (url_entry_collection = (g_list_free (url_entry_collection), NULL));
	}
	_tmp8_ = pc_utils_get_api ();
	_tmp9_ = self->priv->_user;
	_tmp10_ = act_user_get_user_name (_tmp9_);
	_tmp11_ = block_urls;
	_tmp11__length1 = block_urls_length1;
	pc_iparental_controls_set_user_daemon_block_urls (_tmp8_, _tmp10_, _tmp11_, (gint) _tmp11__length1, NULL, NULL);
	block_urls = (_vala_array_free (block_urls, block_urls_length1, (GDestroyNotify) g_free), NULL);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
pc_widgets_internet_box_on_entry_changed (PCWidgetsInternetBox* self)
{
	GRegex* _tmp0_;
	gchar* entry_stripped_text = NULL;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean valid = FALSE;
	GRegex* _tmp4_;
	const gchar* _tmp5_;
	GtkButton* _tmp6_;
	gboolean _tmp7_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->url_regex;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->entry;
	_tmp2_ = gtk_entry_get_text (_tmp1_);
	_tmp3_ = string_strip (_tmp2_);
	entry_stripped_text = _tmp3_;
	_tmp4_ = self->priv->url_regex;
	_tmp5_ = entry_stripped_text;
	valid = g_regex_match (_tmp4_, _tmp5_, 0, NULL);
	_tmp6_ = self->priv->add_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, valid);
	if (valid) {
		_tmp7_ = TRUE;
	} else {
		const gchar* _tmp8_;
		_tmp8_ = entry_stripped_text;
		_tmp7_ = g_strcmp0 (_tmp8_, "") == 0;
	}
	if (_tmp7_) {
		GtkEntry* _tmp9_;
		_tmp9_ = self->priv->entry;
		g_object_set (_tmp9_, "secondary-icon-name", NULL, NULL);
	} else {
		GtkEntry* _tmp10_;
		_tmp10_ = self->priv->entry;
		g_object_set (_tmp10_, "secondary-icon-name", "process-error-symbolic", NULL);
	}
	_g_free0 (entry_stripped_text);
}

static void
pc_widgets_internet_box_on_entry_activate (PCWidgetsInternetBox* self)
{
	GRegex* _tmp0_;
	gchar* url = NULL;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GRegex* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkEntry* _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->url_regex;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->entry;
	_tmp2_ = gtk_entry_get_text (_tmp1_);
	_tmp3_ = string_strip (_tmp2_);
	url = _tmp3_;
	_tmp4_ = self->priv->url_regex;
	_tmp5_ = url;
	if (!g_regex_match (_tmp4_, _tmp5_, 0, NULL)) {
		_g_free0 (url);
		return;
	}
	_tmp6_ = url;
	pc_widgets_internet_box_add_entry (self, _tmp6_);
	_tmp7_ = self->priv->entry;
	gtk_entry_set_text (_tmp7_, "");
	pc_widgets_internet_box_update_block_urls (self);
	_g_free0 (url);
}

static void
__lambda14_ (PCWidgetsInternetBox* self)
{
	pc_widgets_internet_box_update_block_urls (self);
}

static void
___lambda14__gtk_widget_destroy (GtkWidget* _sender,
                                 gpointer self)
{
	__lambda14_ ((PCWidgetsInternetBox*) self);
}

static void
pc_widgets_internet_box_add_entry (PCWidgetsInternetBox* self,
                                   const gchar* url)
{
	PCWidgetsInternetBoxUrlEntry* url_entry = NULL;
	PCWidgetsInternetBoxUrlEntry* _tmp0_;
	GtkListBox* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (url != NULL);
	_tmp0_ = pc_widgets_internet_box_url_entry_new (url);
	g_object_ref_sink (_tmp0_);
	url_entry = _tmp0_;
	g_signal_connect_object ((GtkWidget*) url_entry, "destroy", (GCallback) ___lambda14__gtk_widget_destroy, self, 0);
	_tmp1_ = self->priv->list_box;
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) url_entry);
	_g_object_unref0 (url_entry);
}

ActUser*
pc_widgets_internet_box_get_user (PCWidgetsInternetBox* self)
{
	ActUser* result;
	ActUser* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user;
	result = _tmp0_;
	return result;
}

static void
pc_widgets_internet_box_set_user (PCWidgetsInternetBox* self,
                                  ActUser* value)
{
	ActUser* old_value;
	g_return_if_fail (self != NULL);
	old_value = pc_widgets_internet_box_get_user (self);
	if (old_value != value) {
		self->priv->_user = value;
		g_object_notify_by_pspec ((GObject *) self, pc_widgets_internet_box_properties[PC_WIDGETS_INTERNET_BOX_USER_PROPERTY]);
	}
}

static inline gpointer
pc_widgets_internet_box_url_entry_get_instance_private (PCWidgetsInternetBoxUrlEntry* self)
{
	return G_STRUCT_MEMBER_P (self, PCWidgetsInternetBoxUrlEntry_private_offset);
}

static PCWidgetsInternetBoxUrlEntry*
pc_widgets_internet_box_url_entry_construct (GType object_type,
                                             const gchar* url)
{
	PCWidgetsInternetBoxUrlEntry * self = NULL;
	g_return_val_if_fail (url != NULL, NULL);
	self = (PCWidgetsInternetBoxUrlEntry*) g_object_new (object_type, "url", url, NULL);
	return self;
}

static PCWidgetsInternetBoxUrlEntry*
pc_widgets_internet_box_url_entry_new (const gchar* url)
{
	return pc_widgets_internet_box_url_entry_construct (PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, url);
}

static const gchar*
pc_widgets_internet_box_url_entry_get_url (PCWidgetsInternetBoxUrlEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_url;
	result = _tmp0_;
	return result;
}

static void
pc_widgets_internet_box_url_entry_set_url (PCWidgetsInternetBoxUrlEntry* self,
                                           const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = pc_widgets_internet_box_url_entry_get_url (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_url);
		self->priv->_url = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pc_widgets_internet_box_url_entry_properties[PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY]);
	}
}

static void
_pc_widgets_internet_box_url_entry___lambda13_ (PCWidgetsInternetBoxUrlEntry* self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
__pc_widgets_internet_box_url_entry___lambda13__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self)
{
	_pc_widgets_internet_box_url_entry___lambda13_ ((PCWidgetsInternetBoxUrlEntry*) self);
}

static GObject *
pc_widgets_internet_box_url_entry_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PCWidgetsInternetBoxUrlEntry * self;
	GtkButton* delete_button = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkButton* _tmp3_;
	GtkBox* main_box = NULL;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	const gchar* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkBox* _tmp11_;
	GtkButton* _tmp12_;
	GtkBox* _tmp13_;
	parent_class = G_OBJECT_CLASS (pc_widgets_internet_box_url_entry_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
	_tmp0_ = (GtkButton*) gtk_button_new_from_icon_name ("user-trash-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp0_);
	delete_button = _tmp0_;
	_tmp1_ = delete_button;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	gtk_style_context_add_class (_tmp2_, GTK_STYLE_CLASS_FLAT);
	_tmp3_ = delete_button;
	g_signal_connect_object (_tmp3_, "clicked", (GCallback) __pc_widgets_internet_box_url_entry___lambda13__gtk_button_clicked, self, 0);
	_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp4_);
	main_box = _tmp4_;
	_tmp5_ = main_box;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp5_, 12);
	_tmp6_ = main_box;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp6_, 6);
	_tmp7_ = main_box;
	_tmp8_ = self->priv->_url;
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp10_);
	_g_object_unref0 (_tmp10_);
	_tmp11_ = main_box;
	_tmp12_ = delete_button;
	gtk_box_pack_end (_tmp11_, (GtkWidget*) _tmp12_, FALSE, FALSE, (guint) 0);
	_tmp13_ = main_box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp13_);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (main_box);
	_g_object_unref0 (delete_button);
	return obj;
}

static void
pc_widgets_internet_box_url_entry_class_init (PCWidgetsInternetBoxUrlEntryClass * klass,
                                              gpointer klass_data)
{
	pc_widgets_internet_box_url_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PCWidgetsInternetBoxUrlEntry_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pc_widgets_internet_box_url_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pc_widgets_internet_box_url_entry_set_property;
	G_OBJECT_CLASS (klass)->constructor = pc_widgets_internet_box_url_entry_constructor;
	G_OBJECT_CLASS (klass)->finalize = pc_widgets_internet_box_url_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY, pc_widgets_internet_box_url_entry_properties[PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
pc_widgets_internet_box_url_entry_instance_init (PCWidgetsInternetBoxUrlEntry * self,
                                                 gpointer klass)
{
	self->priv = pc_widgets_internet_box_url_entry_get_instance_private (self);
}

static void
pc_widgets_internet_box_url_entry_finalize (GObject * obj)
{
	PCWidgetsInternetBoxUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
	_g_free0 (self->priv->_url);
	G_OBJECT_CLASS (pc_widgets_internet_box_url_entry_parent_class)->finalize (obj);
}

static GType
pc_widgets_internet_box_url_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCWidgetsInternetBoxUrlEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_widgets_internet_box_url_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCWidgetsInternetBoxUrlEntry), 0, (GInstanceInitFunc) pc_widgets_internet_box_url_entry_instance_init, NULL };
	GType pc_widgets_internet_box_url_entry_type_id;
	pc_widgets_internet_box_url_entry_type_id = g_type_register_static (gtk_list_box_row_get_type (), "PCWidgetsInternetBoxUrlEntry", &g_define_type_info, 0);
	PCWidgetsInternetBoxUrlEntry_private_offset = g_type_add_instance_private (pc_widgets_internet_box_url_entry_type_id, sizeof (PCWidgetsInternetBoxUrlEntryPrivate));
	return pc_widgets_internet_box_url_entry_type_id;
}

static GType
pc_widgets_internet_box_url_entry_get_type (void)
{
	static volatile gsize pc_widgets_internet_box_url_entry_type_id__once = 0;
	if (g_once_init_enter (&pc_widgets_internet_box_url_entry_type_id__once)) {
		GType pc_widgets_internet_box_url_entry_type_id;
		pc_widgets_internet_box_url_entry_type_id = pc_widgets_internet_box_url_entry_get_type_once ();
		g_once_init_leave (&pc_widgets_internet_box_url_entry_type_id__once, pc_widgets_internet_box_url_entry_type_id);
	}
	return pc_widgets_internet_box_url_entry_type_id__once;
}

static void
_vala_pc_widgets_internet_box_url_entry_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	PCWidgetsInternetBoxUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
	switch (property_id) {
		case PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY:
		g_value_set_string (value, pc_widgets_internet_box_url_entry_get_url (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pc_widgets_internet_box_url_entry_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	PCWidgetsInternetBoxUrlEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_INTERNET_BOX_TYPE_URL_ENTRY, PCWidgetsInternetBoxUrlEntry);
	switch (property_id) {
		case PC_WIDGETS_INTERNET_BOX_URL_ENTRY_URL_PROPERTY:
		pc_widgets_internet_box_url_entry_set_url (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_pc_widgets_internet_box_on_entry_activate_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
	pc_widgets_internet_box_on_entry_activate ((PCWidgetsInternetBox*) self);
}

static void
_pc_widgets_internet_box_on_entry_changed_gtk_editable_changed (GtkEditable* _sender,
                                                                gpointer self)
{
	pc_widgets_internet_box_on_entry_changed ((PCWidgetsInternetBox*) self);
}

static void
_pc_widgets_internet_box_on_entry_activate_gtk_entry_activate (GtkEntry* _sender,
                                                               gpointer self)
{
	pc_widgets_internet_box_on_entry_activate ((PCWidgetsInternetBox*) self);
}

static GObject *
pc_widgets_internet_box_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PCWidgetsInternetBox * self;
	GtkLabel* info_label = NULL;
	ActUser* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GtkLabel* _tmp9_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkScrolledWindow* scrolled = NULL;
	GtkScrolledWindow* _tmp15_;
	GtkScrolledWindow* _tmp16_;
	GtkListBox* _tmp17_;
	GtkListBox* _tmp18_;
	GtkScrolledWindow* _tmp19_;
	GtkListBox* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkStyleContext* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkEntry* _tmp27_;
	GtkEntry* _tmp28_;
	GtkEntry* _tmp29_;
	GtkEntry* _tmp30_;
	GtkEntry* _tmp31_;
	GtkEntry* _tmp32_;
	GtkEntry* _tmp33_;
	GtkGrid* main_box = NULL;
	GtkGrid* _tmp34_;
	GtkGrid* _tmp35_;
	GtkGrid* _tmp36_;
	GtkGrid* _tmp37_;
	GtkGrid* _tmp38_;
	GtkGrid* _tmp39_;
	GtkLabel* _tmp40_;
	GtkGrid* _tmp41_;
	GtkSeparator* _tmp42_;
	GtkSeparator* _tmp43_;
	GtkGrid* _tmp44_;
	GtkScrolledWindow* _tmp45_;
	GtkGrid* _tmp46_;
	GtkSeparator* _tmp47_;
	GtkSeparator* _tmp48_;
	GtkGrid* _tmp49_;
	GtkEntry* _tmp50_;
	GtkGrid* _tmp51_;
	GtkButton* _tmp52_;
	GtkFrame* frame = NULL;
	GtkFrame* _tmp53_;
	GtkFrame* _tmp54_;
	GtkStyleContext* _tmp55_;
	GtkFrame* _tmp56_;
	GtkGrid* _tmp57_;
	GtkFrame* _tmp58_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (pc_widgets_internet_box_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		_tmp1_ = g_regex_new (PC_WIDGETS_INTERNET_BOX_URL_REGEX, G_REGEX_OPTIMIZE, 0, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_regex_unref0 (self->priv->url_regex);
		self->priv->url_regex = _tmp2_;
		_g_regex_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("InternetView.vala:68: %s\n", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp5_ = self->priv->_user;
	_tmp6_ = act_user_get_real_name (_tmp5_);
	_tmp7_ = g_strdup_printf (_ ("Prevent %s from visiting these websites:"), _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = (GtkLabel*) gtk_label_new (_tmp8_);
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	info_label = _tmp10_;
	_tmp11_ = info_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp11_, GTK_ALIGN_START);
	_tmp12_ = info_label;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp12_, 12);
	_tmp13_ = info_label;
	_tmp14_ = gtk_widget_get_style_context ((GtkWidget*) _tmp13_);
	gtk_style_context_add_class (_tmp14_, "h4");
	_tmp15_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
	g_object_ref_sink (_tmp15_);
	scrolled = _tmp15_;
	_tmp16_ = scrolled;
	gtk_widget_set_vexpand ((GtkWidget*) _tmp16_, TRUE);
	_tmp17_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->list_box);
	self->priv->list_box = _tmp17_;
	_tmp18_ = self->priv->list_box;
	gtk_list_box_set_selection_mode (_tmp18_, GTK_SELECTION_NONE);
	_tmp19_ = scrolled;
	_tmp20_ = self->priv->list_box;
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = (GtkButton*) gtk_button_new_with_label (_ ("Add URL"));
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->add_button);
	self->priv->add_button = _tmp21_;
	_tmp22_ = self->priv->add_button;
	_tmp23_ = gtk_widget_get_style_context ((GtkWidget*) _tmp22_);
	gtk_style_context_add_class (_tmp23_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp24_ = self->priv->add_button;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp24_, 6);
	_tmp25_ = self->priv->add_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, FALSE);
	_tmp26_ = self->priv->add_button;
	g_signal_connect_object (_tmp26_, "clicked", (GCallback) _pc_widgets_internet_box_on_entry_activate_gtk_button_clicked, self, 0);
	_tmp27_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->entry);
	self->priv->entry = _tmp27_;
	_tmp28_ = self->priv->entry;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp28_, TRUE);
	_tmp29_ = self->priv->entry;
	gtk_widget_set_margin_start ((GtkWidget*) _tmp29_, 6);
	_tmp30_ = self->priv->entry;
	gtk_entry_set_placeholder_text (_tmp30_, _ ("Add a new URL, for example: google.com"));
	_tmp31_ = self->priv->entry;
	gtk_entry_set_icon_tooltip_text (_tmp31_, GTK_ENTRY_ICON_SECONDARY, _ ("Invalid URL"));
	_tmp32_ = self->priv->entry;
	g_signal_connect_object ((GtkEditable*) _tmp32_, "changed", (GCallback) _pc_widgets_internet_box_on_entry_changed_gtk_editable_changed, self, 0);
	_tmp33_ = self->priv->entry;
	g_signal_connect_object (_tmp33_, "activate", (GCallback) _pc_widgets_internet_box_on_entry_activate_gtk_entry_activate, self, 0);
	_tmp34_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp34_);
	main_box = _tmp34_;
	_tmp35_ = main_box;
	gtk_grid_set_column_spacing (_tmp35_, 6);
	_tmp36_ = main_box;
	gtk_grid_set_row_spacing (_tmp36_, 6);
	_tmp37_ = main_box;
	_tmp38_ = main_box;
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp38_, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp37_, 6);
	_tmp39_ = main_box;
	_tmp40_ = info_label;
	gtk_grid_attach (_tmp39_, (GtkWidget*) _tmp40_, 0, 0, 2, 1);
	_tmp41_ = main_box;
	_tmp42_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp42_);
	_tmp43_ = _tmp42_;
	gtk_grid_attach (_tmp41_, (GtkWidget*) _tmp43_, 0, 1, 2, 1);
	_g_object_unref0 (_tmp43_);
	_tmp44_ = main_box;
	_tmp45_ = scrolled;
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 0, 2, 2, 1);
	_tmp46_ = main_box;
	_tmp47_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp47_);
	_tmp48_ = _tmp47_;
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp48_, 0, 3, 2, 1);
	_g_object_unref0 (_tmp48_);
	_tmp49_ = main_box;
	_tmp50_ = self->priv->entry;
	gtk_grid_attach (_tmp49_, (GtkWidget*) _tmp50_, 0, 4, 1, 1);
	_tmp51_ = main_box;
	_tmp52_ = self->priv->add_button;
	gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, 1, 4, 1, 1);
	_tmp53_ = (GtkFrame*) gtk_frame_new (NULL);
	g_object_ref_sink (_tmp53_);
	frame = _tmp53_;
	_tmp54_ = frame;
	_tmp55_ = gtk_widget_get_style_context ((GtkWidget*) _tmp54_);
	gtk_style_context_add_class (_tmp55_, GTK_STYLE_CLASS_VIEW);
	_tmp56_ = frame;
	_tmp57_ = main_box;
	gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
	_tmp58_ = frame;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp58_);
	pc_widgets_internet_box_load_existing (self, NULL, NULL);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (frame);
	_g_object_unref0 (main_box);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (info_label);
	return obj;
}

static void
pc_widgets_internet_box_class_init (PCWidgetsInternetBoxClass * klass,
                                    gpointer klass_data)
{
	pc_widgets_internet_box_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PCWidgetsInternetBox_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pc_widgets_internet_box_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pc_widgets_internet_box_set_property;
	G_OBJECT_CLASS (klass)->constructor = pc_widgets_internet_box_constructor;
	G_OBJECT_CLASS (klass)->finalize = pc_widgets_internet_box_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_WIDGETS_INTERNET_BOX_USER_PROPERTY, pc_widgets_internet_box_properties[PC_WIDGETS_INTERNET_BOX_USER_PROPERTY] = g_param_spec_object ("user", "user", "user", act_user_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
pc_widgets_internet_box_instance_init (PCWidgetsInternetBox * self,
                                       gpointer klass)
{
	self->priv = pc_widgets_internet_box_get_instance_private (self);
	self->priv->url_regex = NULL;
}

static void
pc_widgets_internet_box_finalize (GObject * obj)
{
	PCWidgetsInternetBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
	_g_regex_unref0 (self->priv->url_regex);
	_g_object_unref0 (self->priv->list_box);
	_g_object_unref0 (self->priv->entry);
	_g_object_unref0 (self->priv->add_button);
	G_OBJECT_CLASS (pc_widgets_internet_box_parent_class)->finalize (obj);
}

static GType
pc_widgets_internet_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCWidgetsInternetBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_widgets_internet_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCWidgetsInternetBox), 0, (GInstanceInitFunc) pc_widgets_internet_box_instance_init, NULL };
	GType pc_widgets_internet_box_type_id;
	pc_widgets_internet_box_type_id = g_type_register_static (gtk_grid_get_type (), "PCWidgetsInternetBox", &g_define_type_info, 0);
	PCWidgetsInternetBox_private_offset = g_type_add_instance_private (pc_widgets_internet_box_type_id, sizeof (PCWidgetsInternetBoxPrivate));
	return pc_widgets_internet_box_type_id;
}

GType
pc_widgets_internet_box_get_type (void)
{
	static volatile gsize pc_widgets_internet_box_type_id__once = 0;
	if (g_once_init_enter (&pc_widgets_internet_box_type_id__once)) {
		GType pc_widgets_internet_box_type_id;
		pc_widgets_internet_box_type_id = pc_widgets_internet_box_get_type_once ();
		g_once_init_leave (&pc_widgets_internet_box_type_id__once, pc_widgets_internet_box_type_id);
	}
	return pc_widgets_internet_box_type_id__once;
}

static void
_vala_pc_widgets_internet_box_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PCWidgetsInternetBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
	switch (property_id) {
		case PC_WIDGETS_INTERNET_BOX_USER_PROPERTY:
		g_value_set_object (value, pc_widgets_internet_box_get_user (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pc_widgets_internet_box_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PCWidgetsInternetBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_INTERNET_BOX, PCWidgetsInternetBox);
	switch (property_id) {
		case PC_WIDGETS_INTERNET_BOX_USER_PROPERTY:
		pc_widgets_internet_box_set_user (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

