/* ControlPage.c generated by valac 0.56.8, the Vala compiler
 * generated from ControlPage.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */

#include "parental-controls.h"
#include <act/act.h>
#include <glib-object.h>
#include <glib.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

enum  {
	PC_WIDGETS_CONTROL_PAGE_0_PROPERTY,
	PC_WIDGETS_CONTROL_PAGE_USER_PROPERTY,
	PC_WIDGETS_CONTROL_PAGE_NUM_PROPERTIES
};
static GParamSpec* pc_widgets_control_page_properties[PC_WIDGETS_CONTROL_PAGE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PcWidgetsControlPageGetActiveData PcWidgetsControlPageGetActiveData;

struct _PCWidgetsControlPagePrivate {
	ActUser* _user;
	PCWidgetsTimeLimitView* time_limit_view;
	PCWidgetsAppsBox* apps_box;
};

struct _PcWidgetsControlPageGetActiveData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PCWidgetsControlPage* self;
	gboolean result;
	gboolean _tmp0_;
	PCIParentalControls* _tmp1_;
	ActUser* _tmp2_;
	const gchar* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

static gint PCWidgetsControlPage_private_offset;
static gpointer pc_widgets_control_page_parent_class = NULL;

static void pc_widgets_control_page_get_active_data_free (gpointer _data);
static gboolean pc_widgets_control_page_get_active_co (PcWidgetsControlPageGetActiveData* _data_);
static void pc_widgets_control_page_get_active_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static GObject * pc_widgets_control_page_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void pc_widgets_control_page_finalize (GObject * obj);
static GType pc_widgets_control_page_get_type_once (void);
static void _vala_pc_widgets_control_page_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_pc_widgets_control_page_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
pc_widgets_control_page_get_instance_private (PCWidgetsControlPage* self)
{
	return G_STRUCT_MEMBER_P (self, PCWidgetsControlPage_private_offset);
}

PCWidgetsControlPage*
pc_widgets_control_page_construct (GType object_type,
                                   ActUser* user)
{
	PCWidgetsControlPage * self = NULL;
	g_return_val_if_fail (user != NULL, NULL);
	self = (PCWidgetsControlPage*) g_object_new (object_type, "user", user, NULL);
	return self;
}

PCWidgetsControlPage*
pc_widgets_control_page_new (ActUser* user)
{
	return pc_widgets_control_page_construct (PC_WIDGETS_TYPE_CONTROL_PAGE, user);
}

void
pc_widgets_control_page_set_active (PCWidgetsControlPage* self,
                                    gboolean active)
{
	PolkitPermission* permission = NULL;
	PolkitPermission* _tmp0_;
	PolkitPermission* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pc_utils_get_permission ();
	permission = _tmp0_;
	_tmp1_ = permission;
	_tmp2_ = g_permission_get_allowed ((GPermission*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		PCIParentalControls* _tmp4_;
		ActUser* _tmp5_;
		const gchar* _tmp6_;
		PCWidgetsAppsBox* _tmp7_;
		PCWidgetsTimeLimitView* _tmp8_;
		_tmp4_ = pc_utils_get_api ();
		_tmp5_ = self->priv->_user;
		_tmp6_ = act_user_get_user_name (_tmp5_);
		pc_iparental_controls_set_user_daemon_active (_tmp4_, _tmp6_, active, NULL, NULL);
		_tmp7_ = self->priv->apps_box;
		pc_widgets_apps_box_set_restrictions_active (_tmp7_, active);
		_tmp8_ = self->priv->time_limit_view;
		pc_widgets_time_limit_view_update_pam (_tmp8_, active);
	}
}

static void
pc_widgets_control_page_get_active_data_free (gpointer _data)
{
	PcWidgetsControlPageGetActiveData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (PcWidgetsControlPageGetActiveData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
pc_widgets_control_page_get_active (PCWidgetsControlPage* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	PcWidgetsControlPageGetActiveData* _data_;
	PCWidgetsControlPage* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (PcWidgetsControlPageGetActiveData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, pc_widgets_control_page_get_active_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	pc_widgets_control_page_get_active_co (_data_);
}

gboolean
pc_widgets_control_page_get_active_finish (PCWidgetsControlPage* self,
                                           GAsyncResult* _res_)
{
	gboolean result;
	PcWidgetsControlPageGetActiveData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	return result;
}

static void
pc_widgets_control_page_get_active_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	PcWidgetsControlPageGetActiveData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	pc_widgets_control_page_get_active_co (_data_);
}

static gboolean
pc_widgets_control_page_get_active_co (PcWidgetsControlPageGetActiveData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp1_ = pc_utils_get_api ();
		_data_->_tmp2_ = _data_->self->priv->_user;
		_data_->_tmp3_ = act_user_get_user_name (_data_->_tmp2_);
		_data_->_state_ = 1;
		pc_iparental_controls_get_user_daemon_active (_data_->_tmp1_, _data_->_tmp3_, pc_widgets_control_page_get_active_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp0_ = pc_iparental_controls_get_user_daemon_active_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->result = _data_->_tmp0_;
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp4_ = _data_->e;
		_data_->_tmp5_ = _data_->_tmp4_->message;
		g_warning ("ControlPage.vala:84: %s", _data_->_tmp5_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = FALSE;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

ActUser*
pc_widgets_control_page_get_user (PCWidgetsControlPage* self)
{
	ActUser* result;
	ActUser* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user;
	result = _tmp0_;
	return result;
}

static void
pc_widgets_control_page_set_user (PCWidgetsControlPage* self,
                                  ActUser* value)
{
	ActUser* old_value;
	g_return_if_fail (self != NULL);
	old_value = pc_widgets_control_page_get_user (self);
	if (old_value != value) {
		self->priv->_user = value;
		g_object_notify_by_pspec ((GObject *) self, pc_widgets_control_page_properties[PC_WIDGETS_CONTROL_PAGE_USER_PROPERTY]);
	}
}

static GObject *
pc_widgets_control_page_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PCWidgetsControlPage * self;
	PolkitPermission* permission = NULL;
	PolkitPermission* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	ActUser* _tmp3_;
	PCWidgetsTimeLimitView* _tmp4_;
	PCWidgetsTimeLimitView* _tmp5_;
	PCWidgetsInternetBox* internet_box = NULL;
	ActUser* _tmp6_;
	PCWidgetsInternetBox* _tmp7_;
	PCWidgetsInternetBox* _tmp8_;
	ActUser* _tmp9_;
	PCWidgetsAppsBox* _tmp10_;
	PCWidgetsAppsBox* _tmp11_;
	GtkStack* _tmp12_;
	GtkStack* _tmp13_;
	PCWidgetsTimeLimitView* _tmp14_;
	GtkStack* _tmp15_;
	PCWidgetsInternetBox* _tmp16_;
	GtkStack* _tmp17_;
	PCWidgetsAppsBox* _tmp18_;
	PolkitPermission* _tmp19_;
	PCWidgetsTimeLimitView* _tmp20_;
	PolkitPermission* _tmp21_;
	PCWidgetsInternetBox* _tmp22_;
	PolkitPermission* _tmp23_;
	PCWidgetsAppsBox* _tmp24_;
	GtkStackSwitcher* switcher = NULL;
	GtkStackSwitcher* _tmp25_;
	GtkStackSwitcher* _tmp26_;
	GtkStackSwitcher* _tmp27_;
	GtkStackSwitcher* _tmp28_;
	GtkStack* _tmp29_;
	GtkStackSwitcher* _tmp30_;
	GtkStack* _tmp31_;
	parent_class = G_OBJECT_CLASS (pc_widgets_control_page_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_CONTROL_PAGE, PCWidgetsControlPage);
	_tmp0_ = pc_utils_get_permission ();
	permission = _tmp0_;
	g_object_set ((GtkWidget*) self, "margin", 24, NULL);
	g_object_get ((GtkWidget*) self, "margin", &_tmp1_, NULL);
	_tmp2_ = _tmp1_;
	gtk_box_set_spacing ((GtkBox*) self, _tmp2_);
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp3_ = self->priv->_user;
	_tmp4_ = pc_widgets_time_limit_view_new (_tmp3_);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->time_limit_view);
	self->priv->time_limit_view = _tmp4_;
	_tmp5_ = self->priv->time_limit_view;
	g_object_set ((GtkWidget*) _tmp5_, "expand", TRUE, NULL);
	_tmp6_ = self->priv->_user;
	_tmp7_ = pc_widgets_internet_box_new (_tmp6_);
	g_object_ref_sink (_tmp7_);
	internet_box = _tmp7_;
	_tmp8_ = internet_box;
	g_object_set ((GtkWidget*) _tmp8_, "expand", TRUE, NULL);
	_tmp9_ = self->priv->_user;
	_tmp10_ = pc_widgets_apps_box_new (_tmp9_);
	g_object_ref_sink (_tmp10_);
	_g_object_unref0 (self->priv->apps_box);
	self->priv->apps_box = _tmp10_;
	_tmp11_ = self->priv->apps_box;
	g_object_set ((GtkWidget*) _tmp11_, "expand", TRUE, NULL);
	_tmp12_ = (GtkStack*) gtk_stack_new ();
	g_object_ref_sink (_tmp12_);
	_g_object_unref0 (self->stack);
	self->stack = _tmp12_;
	_tmp13_ = self->stack;
	_tmp14_ = self->priv->time_limit_view;
	gtk_stack_add_titled (_tmp13_, (GtkWidget*) _tmp14_, "general", _ ("Screen Time"));
	_tmp15_ = self->stack;
	_tmp16_ = internet_box;
	gtk_stack_add_titled (_tmp15_, (GtkWidget*) _tmp16_, "internet", _ ("Internet"));
	_tmp17_ = self->stack;
	_tmp18_ = self->priv->apps_box;
	gtk_stack_add_titled (_tmp17_, (GtkWidget*) _tmp18_, "apps", _ ("Applications"));
	_tmp19_ = permission;
	_tmp20_ = self->priv->time_limit_view;
	g_object_bind_property_with_closures ((GObject*) _tmp19_, "allowed", (GObject*) _tmp20_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp21_ = permission;
	_tmp22_ = internet_box;
	g_object_bind_property_with_closures ((GObject*) _tmp21_, "allowed", (GObject*) _tmp22_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp23_ = permission;
	_tmp24_ = self->priv->apps_box;
	g_object_bind_property_with_closures ((GObject*) _tmp23_, "allowed", (GObject*) _tmp24_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp25_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
	g_object_ref_sink (_tmp25_);
	switcher = _tmp25_;
	_tmp26_ = switcher;
	gtk_widget_set_halign ((GtkWidget*) _tmp26_, GTK_ALIGN_CENTER);
	_tmp27_ = switcher;
	gtk_box_set_homogeneous ((GtkBox*) _tmp27_, TRUE);
	_tmp28_ = switcher;
	_tmp29_ = self->stack;
	gtk_stack_switcher_set_stack (_tmp28_, _tmp29_);
	_tmp30_ = switcher;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp30_);
	_tmp31_ = self->stack;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
	gtk_widget_show_all ((GtkWidget*) self);
	_g_object_unref0 (switcher);
	_g_object_unref0 (internet_box);
	return obj;
}

static void
pc_widgets_control_page_class_init (PCWidgetsControlPageClass * klass,
                                    gpointer klass_data)
{
	pc_widgets_control_page_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PCWidgetsControlPage_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pc_widgets_control_page_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pc_widgets_control_page_set_property;
	G_OBJECT_CLASS (klass)->constructor = pc_widgets_control_page_constructor;
	G_OBJECT_CLASS (klass)->finalize = pc_widgets_control_page_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_WIDGETS_CONTROL_PAGE_USER_PROPERTY, pc_widgets_control_page_properties[PC_WIDGETS_CONTROL_PAGE_USER_PROPERTY] = g_param_spec_object ("user", "user", "user", act_user_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
pc_widgets_control_page_instance_init (PCWidgetsControlPage * self,
                                       gpointer klass)
{
	self->priv = pc_widgets_control_page_get_instance_private (self);
}

static void
pc_widgets_control_page_finalize (GObject * obj)
{
	PCWidgetsControlPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_CONTROL_PAGE, PCWidgetsControlPage);
	_g_object_unref0 (self->stack);
	_g_object_unref0 (self->priv->time_limit_view);
	_g_object_unref0 (self->priv->apps_box);
	G_OBJECT_CLASS (pc_widgets_control_page_parent_class)->finalize (obj);
}

static GType
pc_widgets_control_page_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCWidgetsControlPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_widgets_control_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCWidgetsControlPage), 0, (GInstanceInitFunc) pc_widgets_control_page_instance_init, NULL };
	GType pc_widgets_control_page_type_id;
	pc_widgets_control_page_type_id = g_type_register_static (gtk_box_get_type (), "PCWidgetsControlPage", &g_define_type_info, 0);
	PCWidgetsControlPage_private_offset = g_type_add_instance_private (pc_widgets_control_page_type_id, sizeof (PCWidgetsControlPagePrivate));
	return pc_widgets_control_page_type_id;
}

GType
pc_widgets_control_page_get_type (void)
{
	static volatile gsize pc_widgets_control_page_type_id__once = 0;
	if (g_once_init_enter (&pc_widgets_control_page_type_id__once)) {
		GType pc_widgets_control_page_type_id;
		pc_widgets_control_page_type_id = pc_widgets_control_page_get_type_once ();
		g_once_init_leave (&pc_widgets_control_page_type_id__once, pc_widgets_control_page_type_id);
	}
	return pc_widgets_control_page_type_id__once;
}

static void
_vala_pc_widgets_control_page_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PCWidgetsControlPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_CONTROL_PAGE, PCWidgetsControlPage);
	switch (property_id) {
		case PC_WIDGETS_CONTROL_PAGE_USER_PROPERTY:
		g_value_set_object (value, pc_widgets_control_page_get_user (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pc_widgets_control_page_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PCWidgetsControlPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_CONTROL_PAGE, PCWidgetsControlPage);
	switch (property_id) {
		case PC_WIDGETS_CONTROL_PAGE_USER_PROPERTY:
		pc_widgets_control_page_set_user (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

