/* UserItem.c generated by valac 0.56.8, the Vala compiler
 * generated from UserItem.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2015 Adam Bieńkowski (https://launchpad.net/switchboard-plug-parental-controls)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/* Borrowed from https://launchpad.net/switchboard-plug-useraccounts */

#include "parental-controls.h"
#include <gtk/gtk.h>
#include <handy.h>
#include <act/act.h>
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <polkit/polkit.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <pango/pango.h>

enum  {
	PC_WIDGETS_USER_ITEM_0_PROPERTY,
	PC_WIDGETS_USER_ITEM_PAGE_PROPERTY,
	PC_WIDGETS_USER_ITEM_USER_PROPERTY,
	PC_WIDGETS_USER_ITEM_NUM_PROPERTIES
};
static GParamSpec* pc_widgets_user_item_properties[PC_WIDGETS_USER_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PCWidgetsUserItemPrivate {
	PCWidgetsControlPage* _page;
	GtkGrid* grid;
	HdyAvatar* avatar;
	GtkLabel* full_name_label;
	GtkLabel* username_label;
	GtkSwitch* master_switch;
	ActUser* _user;
};

static gint PCWidgetsUserItem_private_offset;
static gpointer pc_widgets_user_item_parent_class = NULL;

static void __lambda15_ (PCWidgetsUserItem* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda15__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static GdkPixbuf* __lambda16_ (PCWidgetsUserItem* self,
                        gint size);
static GdkPixbuf* ___lambda16__hdy_avatar_image_load_func (gint size,
                                                    gpointer self);
static void pc_widgets_user_item_set_user (PCWidgetsUserItem* self,
                                    ActUser* value);
static GObject * pc_widgets_user_item_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _pc_widgets_user_item_update_view_act_user_changed (ActUser* _sender,
                                                         gpointer self);
static void _pc_widgets_user_item___lambda17_ (PCWidgetsUserItem* self);
static void __pc_widgets_user_item___lambda17__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _pc_widgets_user_item_update_view_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void pc_widgets_user_item_finalize (GObject * obj);
static GType pc_widgets_user_item_get_type_once (void);
static void _vala_pc_widgets_user_item_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_pc_widgets_user_item_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
pc_widgets_user_item_get_instance_private (PCWidgetsUserItem* self)
{
	return G_STRUCT_MEMBER_P (self, PCWidgetsUserItem_private_offset);
}

PCWidgetsUserItem*
pc_widgets_user_item_construct (GType object_type,
                                PCWidgetsControlPage* page)
{
	PCWidgetsUserItem * self = NULL;
	g_return_val_if_fail (page != NULL, NULL);
	self = (PCWidgetsUserItem*) g_object_new (object_type, "page", page, NULL);
	return self;
}

PCWidgetsUserItem*
pc_widgets_user_item_new (PCWidgetsControlPage* page)
{
	return pc_widgets_user_item_construct (PC_WIDGETS_TYPE_USER_ITEM, page);
}

static void
__lambda15_ (PCWidgetsUserItem* self,
             GObject* obj,
             GAsyncResult* res)
{
	GtkSwitch* _tmp0_;
	PCWidgetsControlPage* _tmp1_;
	g_return_if_fail (res != NULL);
	_tmp0_ = self->priv->master_switch;
	_tmp1_ = self->priv->_page;
	gtk_switch_set_active (_tmp0_, pc_widgets_control_page_get_active_finish (_tmp1_, res));
}

static void
___lambda15__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda15_ ((PCWidgetsUserItem*) self, source_object, res);
	g_object_unref (self);
}

static GdkPixbuf*
__lambda16_ (PCWidgetsUserItem* self,
             gint size)
{
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
	{
		GdkPixbuf* _tmp0_ = NULL;
		ActUser* _tmp1_;
		const gchar* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
		_tmp1_ = self->priv->_user;
		_tmp2_ = act_user_get_icon_file (_tmp1_);
		_tmp3_ = gdk_pixbuf_new_from_file_at_size (_tmp2_, size, size, &_inner_error0_);
		_tmp0_ = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = _tmp0_;
		_tmp0_ = NULL;
		result = _tmp4_;
		_g_object_unref0 (_tmp0_);
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		g_debug ("UserItem.vala:102: %s", _tmp6_);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

static GdkPixbuf*
___lambda16__hdy_avatar_image_load_func (gint size,
                                         gpointer self)
{
	GdkPixbuf* result;
	result = __lambda16_ ((PCWidgetsUserItem*) self, size);
	return result;
}

void
pc_widgets_user_item_update_view (PCWidgetsUserItem* self)
{
	PCWidgetsControlPage* _tmp0_;
	GtkSwitch* _tmp1_;
	PolkitPermission* _tmp2_;
	GtkLabel* _tmp3_;
	ActUser* _tmp4_;
	const gchar* _tmp5_;
	GtkLabel* _tmp6_;
	ActUser* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	HdyAvatar* _tmp11_;
	ActUser* _tmp12_;
	const gchar* _tmp13_;
	HdyAvatar* _tmp14_;
	GtkGrid* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_page;
	pc_widgets_control_page_get_active (_tmp0_, ___lambda15__gasync_ready_callback, g_object_ref (self));
	_tmp1_ = self->priv->master_switch;
	_tmp2_ = pc_utils_get_permission ();
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, g_permission_get_allowed ((GPermission*) _tmp2_));
	_tmp3_ = self->priv->full_name_label;
	_tmp4_ = self->priv->_user;
	_tmp5_ = act_user_get_real_name (_tmp4_);
	gtk_label_set_label (_tmp3_, _tmp5_);
	_tmp6_ = self->priv->username_label;
	_tmp7_ = self->priv->_user;
	_tmp8_ = act_user_get_user_name (_tmp7_);
	_tmp9_ = g_markup_printf_escaped ("<span font_size=\"small\">%s</span>", _tmp8_);
	_tmp10_ = _tmp9_;
	gtk_label_set_label (_tmp6_, _tmp10_);
	_g_free0 (_tmp10_);
	_tmp11_ = self->priv->avatar;
	_tmp12_ = self->priv->_user;
	_tmp13_ = act_user_get_real_name (_tmp12_);
	hdy_avatar_set_text (_tmp11_, _tmp13_);
	_tmp14_ = self->priv->avatar;
	hdy_avatar_set_image_load_func (_tmp14_, ___lambda16__hdy_avatar_image_load_func, g_object_ref (self), g_object_unref);
	_tmp15_ = self->priv->grid;
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
}

PCWidgetsControlPage*
pc_widgets_user_item_get_page (PCWidgetsUserItem* self)
{
	PCWidgetsControlPage* result;
	PCWidgetsControlPage* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_page;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
pc_widgets_user_item_set_page (PCWidgetsUserItem* self,
                               PCWidgetsControlPage* value)
{
	PCWidgetsControlPage* old_value;
	g_return_if_fail (self != NULL);
	old_value = pc_widgets_user_item_get_page (self);
	if (old_value != value) {
		PCWidgetsControlPage* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_page);
		self->priv->_page = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pc_widgets_user_item_properties[PC_WIDGETS_USER_ITEM_PAGE_PROPERTY]);
	}
}

ActUser*
pc_widgets_user_item_get_user (PCWidgetsUserItem* self)
{
	ActUser* result;
	ActUser* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_user;
	result = _tmp0_;
	return result;
}

static void
pc_widgets_user_item_set_user (PCWidgetsUserItem* self,
                               ActUser* value)
{
	ActUser* old_value;
	g_return_if_fail (self != NULL);
	old_value = pc_widgets_user_item_get_user (self);
	if (old_value != value) {
		self->priv->_user = value;
		g_object_notify_by_pspec ((GObject *) self, pc_widgets_user_item_properties[PC_WIDGETS_USER_ITEM_USER_PROPERTY]);
	}
}

static void
_pc_widgets_user_item_update_view_act_user_changed (ActUser* _sender,
                                                    gpointer self)
{
	pc_widgets_user_item_update_view ((PCWidgetsUserItem*) self);
}

static void
_pc_widgets_user_item___lambda17_ (PCWidgetsUserItem* self)
{
	PCWidgetsControlPage* _tmp0_;
	GtkSwitch* _tmp1_;
	_tmp0_ = self->priv->_page;
	_tmp1_ = self->priv->master_switch;
	pc_widgets_control_page_set_active (_tmp0_, gtk_switch_get_active (_tmp1_));
}

static void
__pc_widgets_user_item___lambda17__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
	_pc_widgets_user_item___lambda17_ ((PCWidgetsUserItem*) self);
}

static void
_pc_widgets_user_item_update_view_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
	pc_widgets_user_item_update_view ((PCWidgetsUserItem*) self);
}

static GObject *
pc_widgets_user_item_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PCWidgetsUserItem * self;
	PCWidgetsControlPage* _tmp0_;
	ActUser* _tmp1_;
	ActUser* _tmp2_;
	ActUser* _tmp3_;
	HdyAvatar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkStyleContext* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkSwitch* _tmp15_;
	GtkSwitch* _tmp16_;
	GtkGrid* _tmp17_ = NULL;
	GtkGrid* _tmp18_;
	HdyAvatar* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* _tmp21_;
	GtkGrid* _tmp22_;
	GtkLabel* _tmp23_;
	GtkGrid* _tmp24_;
	GtkSwitch* _tmp25_;
	GtkSwitch* _tmp26_;
	GtkSwitch* _tmp27_;
	PCWidgetsControlPage* _tmp28_;
	GtkStack* _tmp29_;
	PolkitPermission* _tmp30_;
	GtkGrid* _tmp31_;
	parent_class = G_OBJECT_CLASS (pc_widgets_user_item_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_USER_ITEM, PCWidgetsUserItem);
	_tmp0_ = self->priv->_page;
	_tmp1_ = pc_widgets_control_page_get_user (_tmp0_);
	_tmp2_ = _tmp1_;
	pc_widgets_user_item_set_user (self, _tmp2_);
	_tmp3_ = self->priv->_user;
	g_signal_connect_object (_tmp3_, "changed", (GCallback) _pc_widgets_user_item_update_view_act_user_changed, self, 0);
	_tmp4_ = (HdyAvatar*) hdy_avatar_new (32, NULL, TRUE);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->avatar);
	self->priv->avatar = _tmp4_;
	_tmp5_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp5_);
	_g_object_unref0 (self->priv->full_name_label);
	self->priv->full_name_label = _tmp5_;
	_tmp6_ = self->priv->full_name_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_START);
	_tmp7_ = self->priv->full_name_label;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp7_, TRUE);
	_tmp8_ = self->priv->full_name_label;
	gtk_label_set_ellipsize (_tmp8_, PANGO_ELLIPSIZE_END);
	_tmp9_ = self->priv->full_name_label;
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) _tmp9_);
	gtk_style_context_add_class (_tmp10_, "h3");
	_tmp11_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->username_label);
	self->priv->username_label = _tmp11_;
	_tmp12_ = self->priv->username_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp12_, GTK_ALIGN_START);
	_tmp13_ = self->priv->username_label;
	gtk_label_set_use_markup (_tmp13_, TRUE);
	_tmp14_ = self->priv->username_label;
	gtk_label_set_ellipsize (_tmp14_, PANGO_ELLIPSIZE_END);
	_tmp15_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->master_switch);
	self->priv->master_switch = _tmp15_;
	_tmp16_ = self->priv->master_switch;
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp17_, 12);
	g_object_set ((GtkWidget*) _tmp17_, "margin", 6, NULL);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp17_, 12);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp17_, 12);
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->grid);
	self->priv->grid = _tmp17_;
	_tmp18_ = self->priv->grid;
	_tmp19_ = self->priv->avatar;
	gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp19_, 0, 0, 1, 2);
	_tmp20_ = self->priv->grid;
	_tmp21_ = self->priv->full_name_label;
	gtk_grid_attach (_tmp20_, (GtkWidget*) _tmp21_, 1, 0, 1, 1);
	_tmp22_ = self->priv->grid;
	_tmp23_ = self->priv->username_label;
	gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 1, 1, 1, 1);
	_tmp24_ = self->priv->grid;
	_tmp25_ = self->priv->master_switch;
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 2, 0, 1, 2);
	_tmp26_ = self->priv->master_switch;
	g_signal_connect_object ((GObject*) _tmp26_, "notify::active", (GCallback) __pc_widgets_user_item___lambda17__g_object_notify, self, 0);
	_tmp27_ = self->priv->master_switch;
	_tmp28_ = self->priv->_page;
	_tmp29_ = _tmp28_->stack;
	g_object_bind_property_with_closures ((GObject*) _tmp27_, "active", (GObject*) _tmp29_, "sensitive", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp30_ = pc_utils_get_permission ();
	g_signal_connect_object ((GObject*) _tmp30_, "notify::allowed", (GCallback) _pc_widgets_user_item_update_view_g_object_notify, self, 0);
	pc_widgets_user_item_update_view (self);
	_tmp31_ = self->priv->grid;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
	gtk_widget_show_all ((GtkWidget*) self);
	return obj;
}

static void
pc_widgets_user_item_class_init (PCWidgetsUserItemClass * klass,
                                 gpointer klass_data)
{
	pc_widgets_user_item_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PCWidgetsUserItem_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pc_widgets_user_item_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pc_widgets_user_item_set_property;
	G_OBJECT_CLASS (klass)->constructor = pc_widgets_user_item_constructor;
	G_OBJECT_CLASS (klass)->finalize = pc_widgets_user_item_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_WIDGETS_USER_ITEM_PAGE_PROPERTY, pc_widgets_user_item_properties[PC_WIDGETS_USER_ITEM_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", PC_WIDGETS_TYPE_CONTROL_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PC_WIDGETS_USER_ITEM_USER_PROPERTY, pc_widgets_user_item_properties[PC_WIDGETS_USER_ITEM_USER_PROPERTY] = g_param_spec_object ("user", "user", "user", act_user_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
pc_widgets_user_item_instance_init (PCWidgetsUserItem * self,
                                    gpointer klass)
{
	self->priv = pc_widgets_user_item_get_instance_private (self);
}

static void
pc_widgets_user_item_finalize (GObject * obj)
{
	PCWidgetsUserItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PC_WIDGETS_TYPE_USER_ITEM, PCWidgetsUserItem);
	_g_object_unref0 (self->priv->_page);
	_g_object_unref0 (self->priv->grid);
	_g_object_unref0 (self->priv->avatar);
	_g_object_unref0 (self->priv->full_name_label);
	_g_object_unref0 (self->priv->username_label);
	_g_object_unref0 (self->priv->master_switch);
	G_OBJECT_CLASS (pc_widgets_user_item_parent_class)->finalize (obj);
}

static GType
pc_widgets_user_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PCWidgetsUserItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pc_widgets_user_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PCWidgetsUserItem), 0, (GInstanceInitFunc) pc_widgets_user_item_instance_init, NULL };
	GType pc_widgets_user_item_type_id;
	pc_widgets_user_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "PCWidgetsUserItem", &g_define_type_info, 0);
	PCWidgetsUserItem_private_offset = g_type_add_instance_private (pc_widgets_user_item_type_id, sizeof (PCWidgetsUserItemPrivate));
	return pc_widgets_user_item_type_id;
}

GType
pc_widgets_user_item_get_type (void)
{
	static volatile gsize pc_widgets_user_item_type_id__once = 0;
	if (g_once_init_enter (&pc_widgets_user_item_type_id__once)) {
		GType pc_widgets_user_item_type_id;
		pc_widgets_user_item_type_id = pc_widgets_user_item_get_type_once ();
		g_once_init_leave (&pc_widgets_user_item_type_id__once, pc_widgets_user_item_type_id);
	}
	return pc_widgets_user_item_type_id__once;
}

static void
_vala_pc_widgets_user_item_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	PCWidgetsUserItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_USER_ITEM, PCWidgetsUserItem);
	switch (property_id) {
		case PC_WIDGETS_USER_ITEM_PAGE_PROPERTY:
		g_value_set_object (value, pc_widgets_user_item_get_page (self));
		break;
		case PC_WIDGETS_USER_ITEM_USER_PROPERTY:
		g_value_set_object (value, pc_widgets_user_item_get_user (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pc_widgets_user_item_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	PCWidgetsUserItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PC_WIDGETS_TYPE_USER_ITEM, PCWidgetsUserItem);
	switch (property_id) {
		case PC_WIDGETS_USER_ITEM_PAGE_PROPERTY:
		pc_widgets_user_item_set_page (self, g_value_get_object (value));
		break;
		case PC_WIDGETS_USER_ITEM_USER_PROPERTY:
		pc_widgets_user_item_set_user (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

